Bug 1471970 (CVE-2017-9951)

Summary: CVE-2017-9951 memcached: Heap-based buffer over-read in try_read_command function (incomplete fix for CVE-2016-8705)
Product: [Other] Security Response Reporter: Pedro Sampaio <psampaio>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED ERRATA QA Contact:
Severity: low Docs Contact:
Priority: low    
Version: unspecifiedCC: aortega, apevec, avibelli, chrisw, cvsbot-xmlrpc, drusso, gmollett, hguemar, jbalunas, jjoyce, jmrazek, jorton, jschluet, jshepherd, kbasil, lhh, lindner, lpeer, markmc, matthias, mburns, mlichvar, rbryant, rrajasek, sclewis, slinaber, tdecacqu, tjay, tkirby
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2017-12-07 04:53:44 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Bug Depends On: 1471972, 1485737, 1543405, 1594877    
Bug Blocks: 1485738    

Description Pedro Sampaio 2017-07-17 19:54:19 UTC
The try_read_command function in memcached.c in memcached before 1.4.39 allows remote attackers to cause a denial of service (segmentation fault) via a request to add/set a key, which makes a comparison between signed and unsigned int and triggers a heap-based buffer over-read. NOTE: this vulnerability exists because of an incomplete fix for CVE-2016-8705. 

References:

https://www.twistlock.com/2017/07/13/cve-2017-9951-heap-overflow-memcached-server-1-4-38-twistlock-vulnerability-report/
https://github.com/memcached/memcached/wiki/ReleaseNotes1439
https://groups.google.com/forum/message/raw?msg=memcached/ubGWrkmrr4E/nrm1SeVJAQAJ

Comment 1 Pedro Sampaio 2017-07-17 19:57:04 UTC
Created memcached tracking bugs for this issue:

Affects: fedora-all [bug 1471972]

Comment 2 Jon Schlueter 2017-08-24 18:20:57 UTC
RDO has memcached-1.4.39-1.el7 which includes fix for this CVE according to change log.

Comment 7 Doran Moppert 2017-08-28 03:45:49 UTC
Mitigation:

This flaw is in the memcached binary protocol. If your client programs only use the ASCII protocol when communicating with memcached, you can disable the binary protocol and protect against this flaw by adding "-B ascii" to OPTIONS in /etc/sysconfig/memcached.

Comment 8 Joshua Padman 2017-12-07 05:09:18 UTC
Statement:

Red Hat Product Security has rated this issue as having Low security impact. This issue is not currently planned to be addressed in future updates. For additional information, refer to the Issue Severity Classification: https://access.redhat.com/security/updates/classification/.